{
  "requireCurlyBraces": [
    "if",
    "else",
    "for",
    "while",
    "do",
    "try",
    "catch"
  ],
  "requireOperatorBeforeLineBreak": true,
  "requireCamelCaseOrUpperCaseIdentifiers": true,
  "maximumLineLength": {
    "value": 120,
    "allExcept": ["comments", "regex"]
  },
  "validateIndentation": 4,
  "validateQuoteMarks": "'",

  "disallowMultipleLineStrings": true,
  "disallowMixedSpacesAndTabs": true,
  "disallowTrailingWhitespace": true,
  "disallowSpaceAfterPrefixUnaryOperators": true,
  "disallowMultipleVarDecl": true,
  "disallowKeywordsOnNewLine": ["else"],

  "requireSpaceAfterKeywords": [
    "if",
    "else",
    "for",
    "while",
    "do",
    "switch",
    "return",
    "try",
    "catch"
  ],
  "requireSpaceBeforeBinaryOperators": [
    "=", "+=", "-=", "*=", "/=", "%=", "<<=", ">>=", ">>>=",
    "&=", "|=", "^=", "+=",

    "+", "-", "*", "/", "%", "<<", ">>", ">>>", "&",
    "|", "^", "&&", "||", "===", "==", ">=",
    "<=", "<", ">", "!=", "!=="
  ],
  "requireSpaceAfterBinaryOperators": true,
  "requireSpacesInConditionalExpression": true,
  "requireSpaceBeforeBlockStatements": true,
  "requireSpacesInForStatement": true,
  "requireSpacesInFunctionExpression": {
    "beforeOpeningCurlyBrace": true
  },
  "disallowSpacesInAnonymousFunctionExpression": {
    "beforeOpeningRoundBrace": true
  },
  "disallowSpacesInsideObjectBrackets": "all",
  "disallowSpacesInsideArrayBrackets": "all",
  "disallowSpacesInsideParentheses": true,

  "disallowMultipleLineBreaks": true,
  "disallowNewlineBeforeBlockStatements": true,
  "disallowKeywords": ["with"],
  "disallowSpacesInFunctionExpression": {
    "beforeOpeningRoundBrace": true
  },
  "disallowSpacesInFunctionDeclaration": {
    "beforeOpeningRoundBrace": true
  },
  "disallowSpacesInCallExpression": true,
  "disallowSpaceAfterObjectKeys": true,
  "requireSpaceBeforeObjectValues": true,
  "requireCapitalizedConstructors": true,
  "requireDotNotation": true,
  "requireSemicolons": true,
  "validateParameterSeparator": ", ",

  "jsDoc": {
    "checkAnnotations": {
      "preset": "jsdoc3",
      "extra": {
        "file": true,
        "overview": true,
        "fileoverview": true,
        "private": true,
        "ngdoc":true,
        "methodOf":true,
        "ngInject":true,
        "propertyOf":true,
        "TODO":true,
        "private": true,
        "access": true,
        "usage": true,
        "@return": true,
        "restrict": true
      }
    },
    "checkParamNames": true,
    "requireParamTypes": true,
    "checkRedundantParams": true,
    "checkReturnTypes": true,
    "checkRedundantReturns": true,
    "requireReturnTypes": true,
    "checkTypes": "capitalizedNativeCase",
    "checkRedundantAccess": true,
    "requireNewlineAfterDescription": true
  }
}